import { ElementHandle } from 'puppeteer';
import { PageHelper } from './helpers/pageHelper';
declare const wishes: string[];
declare class BirthdayWisher {
    page: PageHelper;
    /**
     * @param  {string[]} names
     */
    private birthdayQuestions;
    /**
     * @param  {any} answers
     */
    login(answers: any): Promise<void>;
    /**
     * @returns Promise<string[]>
     */
    fetchBirthdayNames(): Promise<string[]>;
    /**
     * @returns Promise<ElementHandle[]>
     */
    fetchAllTexts(): Promise<ElementHandle[]>;
    /**
     * @param  {string[]} birthdayNames
     * @param  {ElementHandle[]} birthdayTexts
     */
    wishAll(birthdayNames: string[], birthdayTexts: ElementHandle[], wish: string): Promise<void>;
    /**
     * @param  {string[]} birthdayNames
     * @param  {ElementHandle[]} birthdayTexts
     */
    birthdayWish(credentials: any, birthdayNames: string[], birthdayTexts: ElementHandle[]): Promise<void>;
    /**
     * @param  {any} credentials
     */
    findAndWish(credentials: any): Promise<void>;
    /**
     * @param  {any} credentials
     * @param  {string} wish
     */
    findAndWishAll(credentials: any, wish: string): Promise<void>;
}
export { BirthdayWisher, wishes };
