"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const crypto_1 = require("./crypto");
const config = require('../../resources/config.json');
const { getInstalledPath } = require('get-installed-path');
const chalk_1 = require("chalk");
const fs = require("fs");
const path = require("path");
const util_1 = require("util");
const writeFileAsync = util_1.promisify(fs.writeFile.bind(fs));
/**
 * @param  {any} file
 */
function writeFile(file) {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            yield writeFileAsync(path.join(yield getInstalledPath('facebook-birthday-cli'), '/resources/config.json'), JSON.stringify(file, null, 4));
        }
        catch (Exception) {
            console.error(chalk_1.default.red('\nFailed to update config.json file! Most likely due to below reason: ') + '\n' +
                Exception.toString());
        }
    });
}
exports.writeFile = writeFile;
/**
 * @param  {any} answers
 */
function encryptCredentials(answers) {
    try {
        config.username = crypto_1.encrypt(answers.username);
        config.password = crypto_1.encrypt(answers.password);
    }
    catch (Exception) {
        throw new Error(Exception);
    }
}
exports.encryptCredentials = encryptCredentials;
/**
 * @param  {any} answers
 */
function decryptCredentials(answers) {
    try {
        answers.username = crypto_1.decrypt(config.username);
        answers.password = crypto_1.decrypt(config.password);
    }
    catch (Exception) {
        throw new Error(Exception);
    }
}
exports.decryptCredentials = decryptCredentials;
//# sourceMappingURL=config.js.map